karaf-dev mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From Jean-Baptiste Onofré ...@nanthrax.net>
Subject Re: [VOTE] Apache Karaf (Container) 4.0.6 release
Date Wed, 24 Aug 2016 11:15:48 GMT
Hi Markus,

can you explain how to reproduce it ?

Is it specific on 4.0.6 or does it happen with 4.0.5 as well ?

Thanks,
Regards
JB

On 08/24/2016 11:19 AM, Markus Rathgeb wrote:
> Hello,
>
> I see this error about missing "osgi.service"
> (filter:="(objectClass=...)";effective:=active) for a lot of features
> at verification now.
>
> I assume it fails for all features that contains a bundle that
> "Require-Capability" contains this requirement, but the bundle
> containing this service does not provide it by the
> "Provide-Capability" information.
>
> The Require-Capability and Provide-Capability information in the
> manifest is added by Bnd (e.g. using maven-bundle-plugin) but there
> are other bundles (for me third party ones) not using Bnd and this
> information is missing.
>
> Do you know if it is possible to instruct the feature resolver to
> satisfy a osgi.service required capability if a implementation of the
> class is present or looking also at the DS files, too?
>
> 2016-08-24 10:22 GMT+02:00 Markus Rathgeb <maggu2810@gmail.com>:
>> Hello,
>>
>> I use a component that imports the Pax Web WebContainer class and
>> depends on a service reference.
>>
>> ===
>> import org.ops4j.pax.web.service.WebContainer;
>> ...
>>
>> @Component(immediate = true)
>> public class Web {
>>
>>     @Reference
>>     private WebContainer webContainer;
>> ...
>> ===
>>
>> My feature looks like this one:
>>
>> ===
>>   <feature>
>>    <bundle>mvn:.../.../${project.version}</bundle>
>>     <feature>scr</feature>
>>     <feature>shell</feature>
>>     <feature>http</feature>
>>     <feature>pax-http-whiteboard</feature>
>>   </feature>
>> ===
>>
>> The verification works using K405.
>> The verification fails using K406 staging
>>
>> (IIRC)
>> K405 is using Pax Web 4.2.6
>> K406 is using Pax Web 4.2.8
>>
>> The error on feature verification is:
>> missing requirement [...] osgi.service;
>> filter:="(objectClass=org.ops4j.pax.web.service.WebContainer)";
>> effective:=active]]
>>
>> So, why is the WebContainer service not satisfied anymore?
>> Is this a change in the Pax Web features (but pax-http and
>> pax-http-whiteboard should satisfy the WebContainer, shouldn't it) or
>> in the feature verification?
>>
>> Thanks in advance,
>> Markus

-- 
Jean-Baptiste Onofré
jbonofre@apache.org
http://blog.nanthrax.net
Talend - http://www.talend.com

Mime
View raw message